import { __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import InputOutline from './InputOutline.js';
import styles from './InputContainer.module.scss.js';

var InputContainer = function (_a) {
  var _b, _c;

  var children = _a.children,
      className = _a.className,
      disabled = _a.disabled,
      focused = _a.focused,
      _d = _a.fontStyle,
      fontStyle = _d === void 0 ? 'regular' : _d,
      inputClassName = _a.inputClassName,
      _e = _a.metadata,
      metadata = _e === void 0 ? {} : _e,
      _f = _a.outline,
      outline = _f === void 0 ? 'default' : _f,
      prefix = _a.prefix,
      _g = _a.prefixVariant,
      prefixVariant = _g === void 0 ? 'transparent' : _g,
      suffix = _a.suffix;
  var inputClassNames = classnames(styles.inputElement, styles.input, (_b = {}, _b[styles.transparentPrefixed] = prefix && prefixVariant === 'transparent', _b[styles.suffixed] = suffix, _b[styles.fontMono] = fontStyle === 'mono', _b), inputClassName);
  var reactInputElement = React.Children.only(children);

  if (! /*#__PURE__*/React.isValidElement(reactInputElement)) {
    throw new Error("InputContainer's child must be a valid React element");
  }

  return /*#__PURE__*/React.createElement(InputOutline, {
    className: className,
    disabled: disabled,
    focused: focused,
    outline: outline
  }, prefix && /*#__PURE__*/React.createElement("span", {
    className: classnames(styles.prefix, (_c = {}, _c[styles['variant-opaque']] = prefixVariant === 'opaque', _c))
  }, prefix), /*#__PURE__*/React.cloneElement(reactInputElement, __assign({
    className: inputClassNames,
    disabled: disabled
  }, parseMetadata(metadata))), suffix && /*#__PURE__*/React.createElement("span", {
    className: styles.suffix
  }, suffix));
};

export { InputContainer as default };
//# sourceMappingURL=InputContainer.js.map
