import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React, { useCallback } from 'react';
import './../external/imask/esm/index.js';
import './../external/react-imask/esm/mixin-4107a9f1.js';
import IMaskInput from './../external/react-imask/esm/input.js';
import './../external/prop-types/index.js';
import './../external/imask/esm/controls/input.js';
import './../external/imask/esm/masked/date.js';
import './../external/imask/esm/masked/pattern.js';
import './../external/imask/esm/masked/base.js';
import './../external/imask/esm/masked/factory.js';
import './../external/imask/esm/masked/regexp.js';
import './../external/imask/esm/masked/range.js';
import './../external/imask/esm/controls/mask-element.js';
import './../external/imask/esm/controls/html-mask-element.js';
import './../external/imask/esm/controls/html-contenteditable-mask-element.js';
import InputContainer from './InputContainer.js';

var MaskedInputWithRef = function (_a, ref) {
  var className = _a.className,
      disabled = _a.disabled,
      focused = _a.focused,
      _b = _a.fontStyle,
      fontStyle = _b === void 0 ? 'regular' : _b,
      inputClassName = _a.inputClassName,
      _c = _a.metadata,
      metadata = _c === void 0 ? {} : _c,
      maskOptions = _a.maskOptions,
      onMaskAccept = _a.onMaskAccept,
      onMaskComplete = _a.onMaskComplete,
      _d = _a.outline,
      outline = _d === void 0 ? 'default' : _d,
      prefix = _a.prefix,
      _e = _a.prefixVariant,
      prefixVariant = _e === void 0 ? 'transparent' : _e,
      suffix = _a.suffix,
      restProps = __rest(_a, ["className", "disabled", "focused", "fontStyle", "inputClassName", "metadata", "maskOptions", "onMaskAccept", "onMaskComplete", "outline", "prefix", "prefixVariant", "suffix"]);

  var handleOnMaskAccept = useCallback(function (value, mask) {
    if (onMaskAccept) {
      onMaskAccept({
        value: value,
        unmaskedValue: mask.unmaskedValue
      });
    }
  }, [onMaskAccept]);
  var handleOnMaskComplete = useCallback(function (value, mask) {
    if (onMaskComplete) {
      onMaskComplete({
        value: value,
        unmaskedValue: mask.unmaskedValue
      });
    }
  }, [onMaskComplete]);
  return /*#__PURE__*/React.createElement(InputContainer, {
    className: className,
    disabled: disabled,
    focused: focused,
    fontStyle: fontStyle,
    inputClassName: inputClassName,
    metadata: metadata,
    outline: outline,
    prefix: prefix,
    prefixVariant: prefixVariant,
    suffix: suffix
  }, /*#__PURE__*/React.createElement(IMaskInput, __assign({
    inputRef: ref
  }, maskOptions, {
    onAccept: handleOnMaskAccept,
    onComplete: handleOnMaskComplete
  }, restProps)));
};

var MaskedInput = /*#__PURE__*/React.forwardRef(MaskedInputWithRef);
export { MaskedInput as default };
//# sourceMappingURL=MaskedInput.js.map
