import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React, { useState } from 'react';
import classnames from 'classnames';
import { forkHandlers, parseMetadata } from '@highlight-ui/utils-commons';
import InputOutline from './InputOutline.js';
import styles from './TextArea.module.scss.js';

function TextAreaWithRef(_a, ref) {
  var _b = _a.className,
      className = _b === void 0 ? '' : _b,
      _c = _a.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = _a.metadata,
      metadata = _d === void 0 ? {} : _d,
      _e = _a.outline,
      outline = _e === void 0 ? 'default' : _e,
      restProps = __rest(_a, ["className", "disabled", "metadata", "outline"]);

  var _f = useState(false),
      isFocused = _f[0],
      setFocus = _f[1];

  return /*#__PURE__*/React.createElement(InputOutline, {
    className: className,
    disabled: disabled,
    focused: isFocused,
    outline: outline
  }, /*#__PURE__*/React.createElement("textarea", __assign({
    className: classnames(styles.textAreaElement, styles.textarea),
    disabled: disabled
  }, parseMetadata(metadata), restProps, {
    ref: ref,
    // TODO: remove these two lines as soon as we drop IE support. (due to :focus-within support)
    onFocus: forkHandlers([function () {
      return setFocus(true);
    }, restProps.onFocus]),
    onBlur: forkHandlers([function () {
      return setFocus(false);
    }, restProps.onBlur])
  })));
}

TextAreaWithRef.displayName = 'TextArea';
var TextArea = /*#__PURE__*/React.forwardRef(TextAreaWithRef);
export { TextArea as default };
//# sourceMappingURL=TextArea.js.map
